#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <ifaddrs.h>
#include <arpa/inet.h>
#include <netinet/in.h>
#include "ifad.h"

char **ifad_get()
{
  char *str[100];
  char ipbuf[INET_ADDRSTRLEN];
  char buf[200];
  int n_addr;
  struct ifaddrs *addr, *ap;
  struct sockaddr_in *in_addr;
  char **R;
  int i;

  if (getifaddrs(&addr))
  {
    perror("getifaddrs");
    goto fail;
  }
  n_addr= 0;
  for(ap=addr;ap;ap=ap->ifa_next)
  {
    if (ap->ifa_addr->sa_family!=AF_INET) continue;
    in_addr= (struct sockaddr_in*) ap->ifa_addr;
    inet_ntop(AF_INET, &in_addr->sin_addr, ipbuf, INET_ADDRSTRLEN);
    memset(buf, 0, sizeof(buf));
    snprintf(buf, sizeof(buf)-1, "%s: %s", ap->ifa_name, ipbuf);
    str[n_addr++]= strdup(buf);
  }
  freeifaddrs(addr);

  R= calloc(n_addr+1, sizeof(*R));
  for(i=0;i<n_addr;i++) R[i]= str[i];
  return R;
fail:
  R= malloc(sizeof(*R));
  R[0]= NULL;
  return R;
}

void ifad_free(char **R)
{
  int i;
  for(i=0;R[i];i++) free(R[i]);
  free(R);
}
