#include <stdio.h>
#include <stdlib.h>
#include "lodepng.h"


int main(int argc, char **argv)
{
  unsigned e, w,h, L, p;
  unsigned char *data;
  unsigned int *wdata, pcol, x,y, i;
  
  e= lodepng_decode24_file(&data, &w, &h,  argv[1]);
  if (e) 
  {
    fprintf(stderr,"decode: %s\n", lodepng_error_text(e));
    return 1;
  }

  L= w*h;
  wdata= malloc(L*4);
  for(i=0;i<L;i++)
  {
    wdata[i]= (unsigned int) data[3*i] << 16 |
              (unsigned int) data[3*i+1] << 8 |
              (unsigned int) data[3*i];
  }
  free(data);

  fprintf(stdout, "static const int CURSORw=%d, CURSORh=%d;\n", w-1, h);
  fprintf(stdout, "static const char CURSORd[]= {\n");

  pcol= wdata[0];
  for(y=0;y<h;y++)
  {
    for(x=1;x<w;x++)
    {
      p= wdata[y*w+x];
      fprintf(stdout, "%d,", p==pcol ? 2 : (p ? 1:0) ); 
    }
    fprintf(stdout,"\n");
  }
  fprintf(stdout, "};\n");

  return 0;
}
